diff -Naur openssl-1.0.0q.orig/addon/elgamal.c openssl-1.0.0q/addon/elgamal.c
--- openssl-1.0.0q.orig/addon/elgamal.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/addon/elgamal.c	2017-04-25 16:23:39.680525594 +0200
@@ -0,0 +1,550 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2008 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+**
+*/
+
+/* addon/elgamal.c */
+/* Parts of this code is modelled or copied from OpenSSL code under the following terms */
+/* Copyright (C) 1995-1998 Eric Young (eay@cryptsoft.com)
+ * All rights reserved.
+ *
+ * This package is an SSL implementation written
+ * by Eric Young (eay@cryptsoft.com).
+ * The implementation was written so as to conform with Netscapes SSL.
+ * 
+ * This library is free for commercial and non-commercial use as long as
+ * the following conditions are aheared to.  The following conditions
+ * apply to all code found in this distribution, be it the RC4, RSA,
+ * lhash, DES, etc., code; not just the SSL code.  The SSL documentation
+ * included with this distribution is covered by the same copyright terms
+ * except that the holder is Tim Hudson (tjh@cryptsoft.com).
+ * 
+ * Copyright remains Eric Young's, and as such any Copyright notices in
+ * the code are not to be removed.
+ * If this package is used in a product, Eric Young should be given attribution
+ * as the author of the parts of the library used.
+ * This can be in the form of a textual message at program startup or
+ * in documentation (online or textual) provided with the package.
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *    "This product includes cryptographic software written by
+ *     Eric Young (eay@cryptsoft.com)"
+ *    The word 'cryptographic' can be left out if the rouines from the library
+ *    being used are not cryptographic related :-).
+ * 4. If you include any Windows specific code (or a derivative thereof) from 
+ *    the apps directory (application code) you must include an acknowledgement:
+ *    "This product includes software written by Tim Hudson (tjh@cryptsoft.com)"
+ * 
+ * THIS SOFTWARE IS PROVIDED BY ERIC YOUNG ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ * 
+ * The licence and distribution terms for any publically available version or
+ * derivative of this code cannot be changed.  i.e. this code cannot simply be
+ * copied and put under another distribution licence
+ * [including the GNU Public Licence.]
+ */
+
+#if defined(NEED_LIBOPEAY_ELGAMAL)
+
+
+#include "modules/libopeay/openssl/cryptlib.h"
+#include "modules/libopeay/openssl/crypto.h"
+#include "modules/libopeay/openssl/err.h"
+#include "modules/libopeay/openssl/buffer.h"
+#include "modules/libopeay/openssl/bn.h"
+#include "modules/libopeay/openssl/rsa.h"
+#include "modules/libopeay/openssl/dh.h"
+#include "modules/libopeay/openssl/rand.h"
+#include "modules/libopeay/openssl/x509.h"
+#include "modules/libopeay/addon/elgamal.h"
+
+#define ElGamal_err(f,r)  ERR_PUT_error(ERR_LIB_USER,(f),(r),__FILE__,__LINE__)
+
+#define ELGAMAL_F_ELGAMAL_ENCRYPT	1
+#define ELGAMAL_F_ELGAMAL_SIGN		2
+#define ELGAMAL_F_ELGAMAL_DECRYPT	3
+#define ELGAMAL_F_ELGAMAL_VERIFY	4
+
+#define ELGAMAL_R_THE_ASN1_OBJECT_IDENTIFIER_IS_NOT_KNOWN_FOR_THIS_MD 1
+#define ELGAMAL_R_PADDING_CHECK_FAILED		2
+#define ELGAMAL_R_UNKNOWN_ALGORITHM_TYPE	3
+#define ELGAMAL_R_DATA_TOO_LARGE_FOR_MODULUS 4
+#define ELGAMAL_R_DIGEST_TOO_BIG_FOR_KEY	5
+#define ELGAMAL_R_WRONG_SIGNATURE_LENGTH	6
+
+#if 0
+int ElGamal_GenerateExchangeKey(DH *dh)
+{
+	BN_CTX *ctx;
+	BIGNUM *p1 ; /* p-1 */
+	BIGNUM *r; /* gcd result; */
+	int l;
+	
+	if(dh == NULL)
+		return -1;
+
+	BN_free(dh->priv_key);
+	BN_free(dh->pub_key);
+	dh->pub_key = NULL;
+	dh->priv_key = NULL;
+
+	ctx = BN_CTX_new();
+	if (ctx == NULL) goto err;
+
+	dh->priv_key=BN_new();
+	if (dh->priv_key == NULL) goto err;
+
+	p1 = BN_new();
+	r = BN_new();
+	if(p1 == NULL || r == NULL) goto err;
+
+	if(!BN_sub(p1, dh->p, BN_value_one())) goto err;
+	
+	l = dh->length ? dh->length : BN_num_bits(dh->p)-1; /* secret exponent length */
+	/* Find a number relatively prime with (p-1) */
+	do{
+		if (!BN_rand(dh->priv_key, l, 0, 0)) goto err;
+		if(!BN_gcd(r, dh->priv_key, p1, ctx)) goto err;
+	}while(BN_cmp(r, BN_value_one()) != 0);
+	
+	if(!BN_mod_exp(r, dh->g, dh->priv_key, dh->p, ctx)) goto err;
+	
+	dh->pub_key = r;
+	r = NULL;
+
+err:;
+	if(p1)
+		BN_free(p1);
+	if(r)
+		BN_free(r);
+	if(ctx)
+		BN_CTX_free(ctx);
+
+	return (dh->pub_key ? 0 : -1);
+}
+#endif
+
+/* modelled on code from rsa_eay.c */
+int ElGamal_encrypt(int flen, const unsigned char *from, unsigned char *to, BIGNUM **a,  DH *dh)
+{
+	BIGNUM y,f, k, p1, ret;
+	int i,j,k1,l,num=0,r= -1;
+	unsigned char *buf=NULL;
+	BN_CTX *ctx=NULL;
+
+	if(a== NULL)
+		return(-1);
+
+	if(*a == NULL)
+		*a = BN_new();
+	if(*a == NULL)
+		return(-1);
+
+	BN_init(&k);
+	BN_init(&y);
+	BN_init(&p1);
+	BN_init(&f);
+	BN_init(&ret);
+	if ((ctx=BN_CTX_new()) == NULL) goto err;
+	num=BN_num_bytes(dh->p);
+	if ((buf=(unsigned char *)OPENSSL_malloc(num)) == NULL)
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_ENCRYPT,ERR_R_MALLOC_FAILURE);
+		goto err;
+		}
+
+	if(!BN_sub(&p1, dh->p, BN_value_one())) goto err;
+
+	l = dh->length ? dh->length : BN_num_bits(dh->p)-1; /* secret exponent length */
+	/* Find a number relatively prime with (p-1) */
+	do{
+		if (!BN_rand(&k, l, 0, 0)) goto err;
+		if(!BN_gcd(&y, &k, &p1, ctx)) goto err;
+	}while(BN_cmp(&y, BN_value_one()) != 0);
+	
+	if(!BN_mod_exp(*a, dh->g, &k, dh->p, ctx)) goto err;
+
+	if(RSA_padding_add_PKCS1_type_2(buf,num,from,flen)<=0) goto err;
+
+	if(BN_bin2bn(buf, num, &f) == NULL)
+		goto err;
+
+	if(!BN_mod_exp(&y, dh->pub_key, &k, dh->p, ctx)) goto err;
+
+	if(!BN_mod_mul(&ret, &y, &f, dh->p, ctx)) goto err;
+
+	j=BN_num_bytes(&ret);
+	i=BN_bn2bin(&ret,&(to[num-j]));
+	for (k1=0; k1<(num-i); k1++)
+		to[k1]=0;
+
+	r=num;
+err:
+	if (ctx != NULL) BN_CTX_free(ctx);
+	BN_clear_free(&y);
+	BN_clear_free(&f);
+	BN_clear_free(&ret);
+	if (buf != NULL) 
+		{
+		op_memset(buf,0,num);
+		OPENSSL_free(buf);
+		}
+	return(r);
+}
+
+int ElGamal_decrypt(int flen, const unsigned char *from, unsigned char *to, BIGNUM *a, DH *dh)
+{
+	BIGNUM y,y1,f,ret;
+	int j,num=0,r= -1;
+	unsigned char *buf=NULL;
+	BN_CTX *ctx=NULL;
+
+	BN_init(&y);
+	BN_init(&y1);
+	BN_init(&f);
+	BN_init(&ret);
+	if(BN_bin2bn(from, flen, &f) != &f) goto err;
+	if ((ctx=BN_CTX_new()) == NULL) goto err;
+
+
+	num=BN_num_bytes(dh->p);
+	if ((buf=(unsigned char *)OPENSSL_malloc(num)) == NULL)
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_ENCRYPT,ERR_R_MALLOC_FAILURE);
+		goto err;
+		}
+
+
+	if (BN_ucmp(&f, dh->p) >= 0)
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_DECRYPT,ELGAMAL_R_DATA_TOO_LARGE_FOR_MODULUS);
+		goto err;
+		}
+
+	if(!BN_mod_exp(&y1, a, dh->priv_key, dh->p, ctx)) goto err;
+	if(!BN_mod_inverse(&y, &y1, dh->p, ctx)) goto err;
+	if(!BN_mod_mul(&ret, &y, &f, dh->p, ctx)) goto err;
+
+	j=BN_bn2bin(&ret,buf); /* j is only used with no-padding mode */
+
+	r = RSA_padding_check_PKCS1_type_2(to,num,buf,j,num);
+	if (r < 0)
+		ElGamal_err(ELGAMAL_F_ELGAMAL_DECRYPT,ELGAMAL_R_PADDING_CHECK_FAILED);
+
+err:
+	if (ctx != NULL) BN_CTX_free(ctx);
+	BN_clear_free(&y1);
+	BN_clear_free(&y);
+	BN_clear_free(&f);
+	BN_clear_free(&ret);
+	if (buf != NULL) 
+		{
+		op_memset(buf,0,num);
+		OPENSSL_free(buf);
+		}
+	return(r);
+}
+
+
+static int ElGamal_perform_sign(int flen, const unsigned char *from, unsigned char *to, BIGNUM **a, DH *dh)
+{
+	BIGNUM y, y1,f, k, p1,ret;
+	int i,j,k1,l,num=0,r= -1;
+	unsigned char *buf=NULL;
+	BN_CTX *ctx=NULL;
+
+	if(a== NULL)
+		return(-1);
+
+	if(*a == NULL)
+		*a = BN_new();
+	if(*a == NULL)
+		return(-1);
+
+	BN_init(&k);
+	BN_init(&p1);
+	BN_init(&y);
+	BN_init(&y1);
+	BN_init(&f);
+	BN_init(&ret);
+	if ((ctx=BN_CTX_new()) == NULL) goto err;
+	num=BN_num_bytes(dh->p);
+	if ((buf=(unsigned char *)OPENSSL_malloc(num)) == NULL)
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_ENCRYPT,ERR_R_MALLOC_FAILURE);
+		goto err;
+		}
+
+	if(!BN_sub(&p1, dh->p, BN_value_one())) goto err;
+
+	l = dh->length ? dh->length : BN_num_bits(dh->p)-1; /* secret exponent length */
+	/* Find a number relatively prime with (p-1) */
+	do{
+		if (!BN_rand(&k, l, 0, 0)) goto err;
+		if(!BN_gcd(&y, &k, &p1, ctx)) goto err;
+	}while(BN_cmp(&y, BN_value_one()) != 0);
+	
+	if(!BN_mod_exp(*a, dh->g, &k, dh->p, ctx)) goto err;
+
+	if(RSA_padding_add_PKCS1_type_2(buf,num,from,flen)<=0) goto err;
+
+	if(BN_bin2bn(buf, num, &f) == NULL)
+		goto err;
+
+	if(!BN_mod_mul(&y, dh->priv_key, *a, &p1, ctx)) goto err;
+
+#ifdef __USE_OPENSSL_097__
+	if(!BN_mod_sub(&y1, &f, &y, &p1, ctx)) goto err;
+#else
+	if(!BN_sub(&ret, &f, &y)) goto err;
+	if(!BN_mod(&y1, &ret, &p1, ctx)) goto err;
+#endif
+
+	if(!BN_mod_inverse(&y, &k, &p1, ctx)) goto err;
+
+	if(!BN_mod_mul(&ret, &y1, &y, &p1, ctx)) goto err;
+
+	j=BN_num_bytes(&ret);
+	i=BN_bn2bin(&ret,&(to[num-j]));
+	for (k1=0; k1<(num-i); k1++)
+		to[k1]=0;
+
+	r=num;
+err:
+	if (ctx != NULL) BN_CTX_free(ctx);
+	BN_clear_free(&k);
+	BN_clear_free(&y1);
+	BN_clear_free(&y);
+	BN_clear_free(&f);
+	BN_clear_free(&ret);
+	if (buf != NULL) 
+	{
+		op_memset(buf,0,num);
+		OPENSSL_free(buf);
+	}
+
+	return r;
+}
+
+int ElGamal_sign(int type, const unsigned char *m, unsigned int m_len,
+	     unsigned char *sigret, unsigned int *siglen, BIGNUM **a, DH *dh)
+	{
+	X509_SIG sig;
+	ASN1_TYPE parameter;
+	int i,j,ret=1;
+	unsigned char *p, *tmps = NULL;
+	const unsigned char *s = NULL;
+	X509_ALGOR algor;
+	ASN1_OCTET_STRING digest;
+
+	if(a == NULL)
+		return 0;
+
+	{
+		sig.algor= &algor;
+		sig.algor->algorithm=OBJ_nid2obj(type);
+		if (sig.algor->algorithm == NULL)
+			{
+			ElGamal_err(ELGAMAL_F_ELGAMAL_SIGN,ELGAMAL_R_UNKNOWN_ALGORITHM_TYPE);
+			return(0);
+			}
+		if (sig.algor->algorithm->length == 0)
+			{
+			ElGamal_err(ELGAMAL_F_ELGAMAL_SIGN,ELGAMAL_R_THE_ASN1_OBJECT_IDENTIFIER_IS_NOT_KNOWN_FOR_THIS_MD);
+			return(0);
+			}
+		parameter.type=V_ASN1_NULL;
+		parameter.value.ptr=NULL;
+		sig.algor->parameter= &parameter;
+
+		sig.digest= &digest;
+		sig.digest->data=(unsigned char *)m; /* TMP UGLY CAST */
+		sig.digest->length=m_len;
+
+		i=i2d_X509_SIG(&sig,NULL);
+	}
+	j=DH_size(dh);
+	if ((i-RSA_PKCS1_PADDING) > j)
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_SIGN,ELGAMAL_R_DIGEST_TOO_BIG_FOR_KEY);
+		return(0);
+		}
+	tmps=(unsigned char *)OPENSSL_malloc((unsigned int)j+1);
+	if (tmps == NULL)
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_SIGN,ERR_R_MALLOC_FAILURE);
+		return(0);
+		}
+	p=tmps;
+	i2d_X509_SIG(&sig,&p);
+	s=tmps;
+
+
+	i = ElGamal_perform_sign(i, s, sigret, a, dh);
+
+	if (i <= 0)
+		ret=0;
+	else
+		*siglen=i;
+
+	op_memset(tmps,0,(unsigned int)j+1);
+	OPENSSL_free(tmps);
+
+	return(ret);
+}
+
+static int ElGamal_perform_verify(const unsigned char *from, int flen, unsigned char *ref, unsigned int ref_len, BIGNUM *a, DH *dh)
+{
+	BIGNUM s1, s2, y, y1,f;
+	int num=0,r= 0;
+	unsigned char *buf=NULL;
+	BN_CTX *ctx=NULL;
+
+	if(a== NULL)
+		return(0);
+
+	BN_init(&s1);
+	BN_init(&s2);
+	BN_init(&y);
+	BN_init(&y1);
+	BN_init(&f);
+	if ((ctx=BN_CTX_new()) == NULL) goto err;
+	num=BN_num_bytes(dh->p);
+	if ((buf=(unsigned char *)OPENSSL_malloc(num)) == NULL)
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_VERIFY,ERR_R_MALLOC_FAILURE);
+		goto err;
+		}
+
+
+	if(RSA_padding_add_PKCS1_type_2(buf,num,from,flen)<=0) goto err;
+
+	if(BN_bin2bn(buf, num, &f) == NULL)
+		goto err;
+
+	/* g^M mod p */
+	if(!BN_mod_exp(&s1, dh->g, &f, dh->p, ctx)) goto err;
+
+	/* y^a mod p */
+	if(!BN_mod_exp(&y, dh->pub_key, a, dh->p, ctx)) goto err;
+
+	if(BN_bin2bn(ref, ref_len, &f) == NULL)
+		goto err;
+
+	/* a^b mod p */
+	if(!BN_mod_mul(&y1, a, &f , dh->p, ctx)) goto err;
+
+	/* (y^a)*(a^b) mod p */
+	if(!BN_mod_mul(&s2, &y, &y1, dh->p, ctx)) goto err;
+
+	if(BN_cmp(&s1, &s2) == 0)
+		r = 1;
+
+err:
+	if (ctx != NULL) BN_CTX_free(ctx);
+	BN_clear_free(&s1);
+	BN_clear_free(&s2);
+	BN_clear_free(&y);
+	BN_clear_free(&y1);
+	BN_clear_free(&f);
+	if (buf != NULL) 
+	{
+		op_memset(buf,0,num);
+		OPENSSL_free(buf);
+	}
+
+	return r;
+}
+
+int ElGamal_verify(int dtype, const unsigned char *m, unsigned int m_len,
+	     unsigned char *sigbuf, unsigned int siglen, BIGNUM *a, DH *dh)
+	{
+	X509_SIG sig;
+	ASN1_TYPE parameter;
+	int i,j,ret=1;
+	unsigned char *p, *tmps = NULL;
+	const unsigned char *s = NULL;
+	X509_ALGOR algor;
+	ASN1_OCTET_STRING digest;
+
+	if(a == NULL)
+		return 0;
+
+	if (siglen > (unsigned int)DH_size(dh))
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_VERIFY,ELGAMAL_R_WRONG_SIGNATURE_LENGTH);
+		return(0);
+		}
+
+	{
+		sig.algor= &algor;
+		sig.algor->algorithm=OBJ_nid2obj(dtype);
+		if (sig.algor->algorithm == NULL)
+			{
+			ElGamal_err(ELGAMAL_F_ELGAMAL_VERIFY,ELGAMAL_R_UNKNOWN_ALGORITHM_TYPE);
+			return(0);
+			}
+		if (sig.algor->algorithm->length == 0)
+			{
+			ElGamal_err(ELGAMAL_F_ELGAMAL_VERIFY,ELGAMAL_R_THE_ASN1_OBJECT_IDENTIFIER_IS_NOT_KNOWN_FOR_THIS_MD);
+			return(0);
+			}
+		parameter.type=V_ASN1_NULL;
+		parameter.value.ptr=NULL;
+		sig.algor->parameter= &parameter;
+
+		sig.digest= &digest;
+		sig.digest->data=(unsigned char *)m; /* TMP UGLY CAST */
+		sig.digest->length=m_len;
+
+		i=i2d_X509_SIG(&sig,NULL);
+	}
+	j=DH_size(dh);
+	if ((i-RSA_PKCS1_PADDING) > j)
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_VERIFY,ELGAMAL_R_DIGEST_TOO_BIG_FOR_KEY);
+		return(0);
+		}
+	tmps=(unsigned char *)OPENSSL_malloc((unsigned int)j+1);
+	if (tmps == NULL)
+		{
+		ElGamal_err(ELGAMAL_F_ELGAMAL_VERIFY,ERR_R_MALLOC_FAILURE);
+		return(0);
+		}
+	p=tmps;
+	i2d_X509_SIG(&sig,&p);
+	s=tmps;
+
+	ret = ElGamal_perform_verify(s, i, sigbuf, siglen, a, dh);
+
+	op_memset(tmps,0,(unsigned int)j+1);
+	OPENSSL_free(tmps);
+
+	return(ret);
+}
+
+
+#endif
+
diff -Naur openssl-1.0.0q.orig/addon/elgamal.h openssl-1.0.0q/addon/elgamal.h
--- openssl-1.0.0q.orig/addon/elgamal.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/addon/elgamal.h	2017-04-25 16:23:39.681528795 +0200
@@ -0,0 +1,23 @@
+
+#ifndef _ELGAMAL_H_
+#define _ELGAMAL_H_
+
+#ifdef NEED_LIBOPEAY_ELGAMAL
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+/*int ElGamal_GenerateExchangeKey(DH *dh);*/
+int ElGamal_encrypt(int flen, const unsigned char *from, unsigned char *to, BIGNUM **a, DH *dh);
+int ElGamal_decrypt(int flen, const unsigned char *from, unsigned char *to, BIGNUM *a, DH *dh);
+int ElGamal_sign(int type, const unsigned char *m, unsigned int m_len,
+	     unsigned char *sigret, unsigned int *siglen, BIGNUM **a, DH *dh);
+int ElGamal_verify(int dtype, const unsigned char *m, unsigned int m_len,
+	     unsigned char *sigbuf, unsigned int siglen, BIGNUM *a, DH *dh);
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
+#endif
diff -Naur openssl-1.0.0q.orig/addon/libopeay_util.h openssl-1.0.0q/addon/libopeay_util.h
--- openssl-1.0.0q.orig/addon/libopeay_util.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/addon/libopeay_util.h	2017-04-25 16:23:39.684527500 +0200
@@ -0,0 +1,28 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 2012-2012 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+/**
+ * @file libopeay_util.h
+ *
+ * Utility functions.
+ *
+ * @author Alexei Khlebnikov <alexeik@opera.com>
+ *
+ */
+
+#ifndef LIBOPEAY_UTIL_H
+#define LIBOPEAY_UTIL_H
+
+#if defined(_DEBUG) || defined(SELFTEST)
+
+const char* EVP_PKEY_type_name(int pkey_type);
+const char* X509_V_ERR_name(int err);
+
+#endif // defined(_DEBUG) || defined(SELFTEST)
+
+#endif // LIBOPEAY_UTIL_H
diff -Naur openssl-1.0.0q.orig/addon/op_functions.h openssl-1.0.0q/addon/op_functions.h
--- openssl-1.0.0q.orig/addon/op_functions.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/addon/op_functions.h	2017-04-25 16:23:39.685526789 +0200
@@ -0,0 +1,237 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 2011 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+/**
+ * @file op_functions.h
+ *
+ * Substitution of standard C calls with op_ calls, if needed.
+ *
+ * This file introduces an exception to Opera Core op_ prefix rule.
+ * This exception is only introduced for libopeay module, because it
+ * contains mostly 3rd party OpenSSL code and we can't force OpenSSL
+ * developers to adopt our op_ prefix rule. If this exception will
+ * not work on all supported platforms - it will be removed.
+ *
+ * If you are curious and want more info about the problem, please read
+ * the relevant discussion in developer@opera.com maillist, August 2011,
+ * subject "op_ prefix". Here is the a copy of the exception proposal
+ * from that discussion:
+ *
+
+<quote>
+From: "Alexei Khlebnikov" <alexei.khlebnikov@opera.com>
+Subject: Re: [Developer] op_ prefix
+Date: Mon, 08 Aug 2011 14:43:44 +0200
+
+...
+
+I want to introduce an exception to the op-prefix rule for at least some
+3rd-party code, because we can't make upstream developers to adopt our
+op-prefix rule. I want to apply this exception to libopeay (OpenSSL),
+but it can also be useful for lea_malloc, libfreetype and zlib,
+if their owners will want it.
+
+We now have op_calls everywhere in libopeay. It means we have a lot of local
+patches that only exist to satisfy our op-prefix rule. We currently have
+3.7 MB of local patches between "vanilla" OpenSSL and libopeay
+("diff -Nura" with default 3 lines of context). Of course, our local patches do not consist entirely of changing non-op_calls to op_calls, but such changes are a big share of all patches, more than half of them.
+
+I am now upgrading OpenSSL and have a lot merge conflicts because of that.
+Also, I need to replace newly-added non-op_calls by op_calls. I can write
+a script for such replacements, but I am upgrading directory-by-directory,
+so I'll need to run it many times anyway, and this script will not save me
+from all those manual merge conflict resolutions.
+
+Thus I want to make a header, local to libopeay, that will contain blocks like
+
+    #if SYSTEM_MEMSET == NO
+    # undef memset
+    # define memset op_memset
+    #endif
+
+for every function which is a part of system system and has a SYSTEM_* define.
+I am going to include this header into every (autogenerated) .cpp file
+of libopeay, but none of its .h files, thus other modules won't be "poisoned".
+Those rare system function calls from .h files, if they exist, will be
+converted to op_calls anyway, so that other modules including headers
+from libopeay will be able to compile. Other arrangements can be done,
+the point is to remove as many local patches as possible, even if it won't be
+possible to remove all of them.
+
+Why it should work for all projects. All projects have to define SYSTEM_MEMSET
+correctly to YES or NO. Otherwise they'll get a compilation error immediately,
+according to this code in modules/hardcore/base/system.h:
+
+
+    #if !defined SYSTEM_MEMSET || (SYSTEM_MEMSET != YES && SYSTEM_MEMSET != NO)
+    #   error "You need to decide if you want SYSTEM_MEMSET or not."
+    #   error " The system has the following function:"
+    #   error ""
+    #   error " void* memset(void* s1, int n, size_t nbytes);"
+    #   error ""
+    #   error " If SYSTEM_MEMSET==NO then the macro op_memset need not be defined."
+    #   error ""
+    #endif // SYSTEM_MEMSET
+
+And these definitions will be visible in all the Core code. Thus my code
+
+    #if SYSTEM_MEMSET == NO
+    # undef memset
+    # define memset op_memset
+    #endif
+
+will behave the following way:
+
+1) If system memset is used and SYSTEM_MEMSET == YES:
+#undef and #define will be ignored, memset will be defined to whatever it was
+previously defined on the system.
+
+2) If system memset is not used and SYSTEM_MEMSET == NO:
+memset will be defined as op_memset, which in turn can be defined as any
+(weird) platform-specific function or Opera's implementation of this function
+can be taken.
+
+Regarding Eddy's point about exotic functions like wcsnicoll. I haven't seen
+exotic function calls in OpenSSL. It is mostly functions from string.h: str*()
+and mem*(). So what will happen if such functions still exist or will be
+introduced? As I said, I am only going to introduce the mentioned code blocks
+for functions in system system, which have corresponding SYSTEM_* define.
+So those exotic functions are not affected by my proposal and their linking
+will be solved another way, as it would be without this proposal.
+
+Regarding Jakub's point about memory allocation. AFAIU, you are talking about
+op_malloc and op_free. When using own memory allocator, you define,
+for example, op_malloc as own_malloc and op_free as own_free. You don't use
+system's malloc and free and have SYSTEM_MALLOC == NO. In this case "plain"
+malloc will be substituted by the preprocessor by op_malloc and then
+by own_malloc. So it's transparent. OP_NEW and OP_DELETE are unaffected
+by this proposal, because OpenSSL is pure C code and OP_NEW/OP_DELETE
+do not have corresponding SYSTEM_* macros.
+
+I'd like to repeat, I want to introduce this exception only for one module,
+containing 3rd-party code. Not for the whole Core. If it won't work, we can
+switch to "total op-prefix" again.
+</quote>
+
+ * Documentation update 2012-04-13:
+
+It turned out that YES, NO and SYSTEM_* defines are undefined in the end
+of modules/hardcore/base/system.h, which is included by core/pch.h,
+i.e. before this file (op_functions.h). Thus we can't rely on SYSTEM_*
+defines. But before each SYSTEM_X is undefined, each SYSTEM_X is converted
+into the corresponding HAVE_X:
+
+#if SYSTEM_MEMSET == YES
+#	define HAVE_MEMSET
+#endif // SYSTEM_MEMSET == YES
+
+Thus we can use HAVE_* defines.
+
+ *
+ * @author Alexei Khlebnikov <alexeik@opera.com>
+ *
+ */
+
+#ifdef OP_FUNCTIONS_H
+#error This file must be included exactly once, from modules/libopeay/core_includes.h.
+#endif
+#define OP_FUNCTIONS_H
+
+#ifndef HAVE_ATOI
+# undef  atoi
+# define atoi op_atoi
+#endif
+
+#ifndef HAVE_GMTIME
+# undef  gmtime
+# define gmtime op_gmtime
+#endif
+
+#ifndef HAVE_MEMCMP
+# undef  memcmp
+# define memcmp op_memcmp
+#endif
+
+#ifndef HAVE_MEMCPY
+# undef  memcpy
+# define memcpy op_memcpy
+#endif
+
+#ifndef HAVE_MEMMOVE
+# undef  memmove
+# define memmove op_memmove
+#endif
+
+#ifndef HAVE_MEMSET
+# undef  memset
+# define memset op_memset
+#endif
+
+#ifndef HAVE_SSCANF
+# undef  sscanf
+# define sscanf op_sscanf
+#endif
+
+#ifndef HAVE_STRCHR
+# undef  strchr
+# define strchr op_strchr
+#endif
+
+#ifndef HAVE_STRCMP
+# undef  strcmp
+# define strcmp op_strcmp
+#endif
+
+#ifndef HAVE_STRCPY
+# undef  strcpy
+# define strcpy op_strcpy
+#endif
+
+#ifndef HAVE_STRICMP
+# undef  stricmp
+# define stricmp op_stricmp
+# undef  strcasecmp
+# define strcasecmp op_stricmp
+#endif
+
+#ifndef HAVE_STRLEN
+# undef  strlen
+# define strlen op_strlen
+#endif
+
+#ifndef HAVE_STRNCMP
+# undef  strncmp
+# define strncmp op_strncmp
+#endif
+
+#ifndef HAVE_STRNCPY
+# undef  strncpy
+# define strncpy op_strncpy
+#endif
+
+#ifndef HAVE_STRNICMP
+# undef  strnicmp
+# define strnicmp op_strnicmp
+# undef  strncasecmp
+# define strncasecmp op_strnicmp
+#endif
+
+#ifndef HAVE_STRSTR
+# undef  strstr
+# define strstr op_strstr
+#endif
+
+#ifndef HAVE_STRTOUL
+# undef  strtoul
+# define strtoul op_strtoul
+#endif
+
+#ifndef HAVE_TOLOWER
+# undef  tolower
+# define tolower op_tolower
+#endif
diff -Naur openssl-1.0.0q.orig/addon/purposes.c openssl-1.0.0q/addon/purposes.c
--- openssl-1.0.0q.orig/addon/purposes.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/addon/purposes.c	2017-04-25 16:23:39.693527806 +0200
@@ -0,0 +1,122 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
+**
+**
+** Copyright (C) 2000-2011 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+**
+** Yngve Pettersen
+**
+*/
+
+/* This file contains modified versions of code found in OpenSSL */
+
+/* ====================================================================
+ * Copyright (c) 1999 The OpenSSL Project.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer. 
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. All advertising materials mentioning features or use of this
+ *    software must display the following acknowledgment:
+ *    "This product includes software developed by the OpenSSL Project
+ *    for use in the OpenSSL Toolkit. (http://www.OpenSSL.org/)"
+ *
+ * 4. The names "OpenSSL Toolkit" and "OpenSSL Project" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For written permission, please contact
+ *    licensing@OpenSSL.org.
+ *
+ * 5. Products derived from this software may not be called "OpenSSL"
+ *    nor may "OpenSSL" appear in their names without prior written
+ *    permission of the OpenSSL Project.
+ *
+ * 6. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by the OpenSSL Project
+ *    for use in the OpenSSL Toolkit (http://www.OpenSSL.org/)"
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY
+ * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE OpenSSL PROJECT OR
+ * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
+ * OF THE POSSIBILITY OF SUCH DAMAGE.
+ * ====================================================================
+ *
+ * This product includes cryptographic software written by Eric Young
+ * (eay@cryptsoft.com).  This product includes software written by Tim
+ * Hudson (tjh@cryptsoft.com).
+ *
+ */
+#include <openssl/cryptlib.h>
+#include "modules/libopeay/addon/purposes.h"
+
+
+/* borrowed from v3_purp.c */
+
+/* CA checks common to all purposes
+ * return codes:
+ * 0 not a CA
+ * 1 is a CA
+ * 2 basicConstraints absent so "maybe" a CA
+ * 3 basicConstraints absent but self signed V1.
+ */
+
+#define V1_ROOT (EXFLAG_V1|EXFLAG_SS)
+#define ku_reject(x, usage) \
+	(((x)->ex_flags & EXFLAG_KUSAGE) && !((x)->ex_kusage & (usage)))
+#define xku_reject(x, usage) \
+	(((x)->ex_flags & EXFLAG_XKUSAGE) && !((x)->ex_xkusage & (usage)))
+#define ns_reject(x, usage) \
+	(((x)->ex_flags & EXFLAG_NSCERT) && !((x)->ex_nscert & (usage)))
+
+int trust_1oidany(X509_TRUST *trust, X509 *x, int flags);
+int check_ca(const X509 *x);
+
+/* Check SSL CA: common checks for SSL client and server */
+static int check_codesign_ca(const X509 *x)
+{
+	int ca_ret;
+	ca_ret = check_ca(x);
+	if(!ca_ret) return 0;
+	/* check nsCertType if present */
+	if(x->ex_flags & EXFLAG_NSCERT) {
+		if(x->ex_nscert & NS_OBJSIGN_CA) return ca_ret;
+		return 0;
+	}
+	if(ca_ret != 2) return ca_ret;
+	else return 0;
+}
+
+static int check_purpose_code_signing(const X509_PURPOSE *xp, const X509 *x, int ca)
+{
+	if(xku_reject(x,XKU_CODE_SIGN)) return 0;
+	if(ca) return check_codesign_ca(x);
+	if(ns_reject(x, NS_OBJSIGN)) return 0;
+	/* We need to do digital signatures with it */
+	if(ku_reject(x,KU_DIGITAL_SIGNATURE)) return 0;
+	return 1;
+}
+
+// Called only by LibopeayModule::InitL().
+int AddOperaSpecificPurposes()
+{
+	return X509_PURPOSE_add(OPERA_X509_PURPOSE_CODE_SIGN, X509_TRUST_OBJECT_SIGN, 0, check_purpose_code_signing, "Code signing", "codesign", NULL);
+}
diff -Naur openssl-1.0.0q.orig/addon/purposes.h openssl-1.0.0q/addon/purposes.h
--- openssl-1.0.0q.orig/addon/purposes.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/addon/purposes.h	2017-04-25 16:23:39.694527653 +0200
@@ -0,0 +1,19 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2011 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#ifndef PURPOSES_H
+#define PURPOSES_H
+
+#if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+
+#include <openssl/x509v3.h>
+
+#define OPERA_X509_PURPOSE_CODE_SIGN		(X509_PURPOSE_MAX + 1)
+
+#endif // defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+#endif // PURPOSES_H
